import random

from command_system import as_plugin, RollbotResponse


HELP_MSG = """
Hello!
I am Rollbot 2.0 - a reimplementation of the previous Rollbot.
I am a simple chatbot built in Python.
I am licensed as open source under the MIT license.
I can perform some basic operations, by using one of the following commands.
I also have "secret" functionality as well - feel free to try other commands!

!info - print this message.

!echo <text> - echo back the provided text.

!greet - print a simple greeting.

!thanks - tell me thanks!

!roll <expr> - roll a set of dice, or solve a simple math problem.
This uses the Python dice library.

!teamspeak - see who is in TeamSpeak currently. Not guaranteed to work!
Telnet is complicated!

!session <action> {<arg>} - manage the next DnD session
    next (<date>|<day>) [<time>] - set the next session's date and time
    view - view the date and time of the next session
    late - determine how late you are for the next session
    cancel [<blame>] - cancel the next session, and optionally blame someone
    worst - see who is causing the most last-minute cancellations
"""


@as_plugin
def info(db, message):
    return RollbotResponse(message, txt=HELP_MSG)


@as_plugin
def isadmin(db, message):
    return RollbotResponse(message, txt=str(message.from_admin))


@as_plugin
def debug(db, message):
    return RollbotResponse(message, txt=str(message))


@as_plugin
def echo(db, message):
    return RollbotResponse(message, txt="'%s' - %s" % (message.raw_args, message.name))


@as_plugin
def thanks(db, message):
    return RollbotResponse(message, txt="You're welcome!")


@as_plugin
def guess(db, message):
    return RollbotResponse(message, txt="Rollbot's back - tell a friend!")


@as_plugin
def meme(db, message):
    return RollbotResponse(message, txt="fuck off")


@as_plugin
def unmeme(db, message):
    return RollbotResponse(message, txt="get a job")


@as_plugin
def greet(db, message):
    return RollbotResponse(message, txt=random.choice(("Hi!", "Hello!", "안녕하세요", "こんにちは", "你好", "👋")))


@as_plugin
def console(db, message):
    argstr = message.raw_args
    opts = [
        "NEVER GIVE UP",
        "I believe in you!",
        "You're doing your best, it's okay!"
    ]
    if argstr is not None:
        opts.append("It'll be okay, {}! Keep trying!".format(argstr))
    return RollbotResponse(message, txt=random.choice(opts))
